<?php
class Template {
	public $db;
	public static $important_template;
	public static $important_template_module = array();
	public static $id;
	private $url;
	private static $title;
	private static $og_title;
	private static $og_img;
	private static $content;
	private static $keywords;
	private static $description;
	private static $template;

	const PAGE_TEMPLATES_DIR = 'page-templates';

	public function __construct($db)
	{
		$this->db = $db;
	}
	public function prepare($url)
	{
		$this->url = $url;
		if(isset(Router::$_DATA['id']) and !empty(Router::$_DATA['id'])){
			self::$id = Router::$_DATA['id']; 
			self::$title = Router::$_DATA['og_title'];
			self::$description = Router::$_DATA['og_description'];
			self::$template = Router::$_DATA['template'];
		}else{

			if(empty($this->url) OR (Router::is_final()) ){
				return;
			}
			$data = $this->db->select()->from('pages')->where(array('url'=>$url))->fetchSingle();
			if(is_null($data) && $url == '/'){
				$this->load_home();
			}else{
				self::$id = $data['id'];
				self::$title = $data['og_title'];
				self::$description = $data['og_description'];
				self::$template = $data['template'];
			}
		}
	}
	public function load_404()
	{
		$this->url = "404";
		self::$title = '404';
		self::$description = 'Neznáma stránka';
		self::$template = '404';
	}

	public function load_home()
	{
		global $router;
		$router->load_home();
	}
	public static function template($template_file,$name_module = false){
		if($name_module){
			self::$important_template_module['file'] = $template_file;
			self::$important_template_module['name_module'] = $name_module;
		}else{
			self::$important_template = $template_file;
		}
	}
	public function render()
	{
		$template_file = slash(THEMES_DIR.self::PAGE_TEMPLATES_DIR . '/');
		if(isset(self::$important_template)){
			$template_file .= self::$important_template;
		}else if(self::$important_template_module){
			$template_file = slash(MODULES_DIR.self::$important_template_module['name_module']."/templates/".self::$important_template_module['file']);
		}else{
			$template_file .= self::$template.".php";
		}
		require_once INCLUDES_DIR . 'template-functions.php';


		if(file_exists($template_file)){
			return $template_file;
		}

		return false;
	}
	public static function set_title($title)
	{
		self::$title = $title;

	}
	public static function get_title()
	{
		return self::$title;
	}
	public static function set_og_title($title)
	{
		self::$og_title = $title;

	}
	public static function get_og_title()
	{
		return self::$og_title;

	}

	public static function set_og_img($img)
	{
		self::$og_img = $img;

	}
	public static function get_og_img()
	{
		return self::$og_img;

	}

	public static function get_template_name()
	{
		return self::$template;
	}

	public static function set_description($description)
	{
		self::$description = $description;
	}

	public static function get_description()
	{
		return self::$description;
	}

}